#pragma once

#define DATA_LOCATION		"..\\..\\data\\"
#define GRAPH_LOCATION		"..\\..\\graphs\\"
#define EXEC_LOCATION  ".\\exec\\"

#define MAX_FILENAME_LEN	200
#define MAX_LINE_LEN	500
#define MAX_COMD_LEN	500


struct PATTERN
{
	int *pitemset;
	int length;
	int support;
	PATTERN *next;
};

void CompPatterns(char *pat_filename1, char *pat_filename2);
void LoadPatterns(char *pat_filename, PATTERN* &ppatset);

int comp_int_asc(const void *e1, const void *e2);
bool IsEqual(int *set1, int *set2, int length);
bool IsSubset(int *set1, int len1, int *set2, int len2);


//mining routines
void MineFCI(char* szprogram_name, char *dataset_name, int ntype, int start_min_sup, int iterations, int inc_step, bool bout);

void MineBPSize(char* szprogram_name, char *dataset_name, int ntype, int nmin_sup, int start_min_size, int iterations, int inc_step, bool bout);
void MineBPSup(char* szprogram_name, char *dataset_name, int ntype, int nmin_size, int start_min_sup, int iterations, int inc_step, bool bout);
void MineBPSupSize(char* szprogram_name, char *dataset_name, int ntype, int start_min_sup, int iterations, int inc_step, bool bout);

void MICASize(char *dataset_name, int ntype, int nmin_sup, int start_min_size, int iterations, int inc_step, bool bout);
void MICASup(char *dataset_name, int ntype, int nmin_size, int start_min_sup, int iterations, int inc_step, bool bout);
void MICASupSize(char *dataset_name, int ntype, int start_min_sup, int iterations, int inc_step, bool bout);


//generating tid lists for large itemsets

typedef struct 
{
	int nitem;
	int length;
	int* pclosure;
} ITEM_NODE;
void GenTList(char* szdataset_name, int ntype, int nmin_sup, int nmin_size, char* szpat_filename, char* szoutput_filename);


//convert adjacent list to edges 
void AdjList2Edges(char* szdataset_name, int ntype);

void GenGraph(int num_of_vertices, double prob, double alpha);

extern int gnum_of_bps;


