#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>
#include "Global.h"

void MineBP(char* szprogram_name, char* szdataset_name, int ntype, int nmin_sup, int nmin_size, char *szoutput_filename);

int gnum_of_bps;

int main(int argc, char* argv[])
{
	int ntype, nmin_sup, nmin_size;

	if(argc!=6)
	{
		printf("Usage\n");
		printf("\t%s  data_filename data_type nmin_sup  nmin_size output_filename\n", argv[0]);
		return 0;
	}

	ntype = atoi(argv[2]);
	nmin_sup = atoi(argv[3]);
	if(nmin_sup<1)
	{
		printf("Please specify a native number for the minimum support threshold\n");
		return 0;
	}
	nmin_size = atoi(argv[4]);
	if(nmin_size<1)
	{
		printf("Please specify a native number for the minimum support threshold\n");
		return 0;
	}

	MineBP("./LCMnew", argv[1], ntype, nmin_sup, nmin_size, argv[5]);

	return gnum_of_bps;

}


void MineBP(char* szprogram_name, char* szdataset_name, int ntype, int nmin_sup, int nmin_size, char *szoutput_filename)
{
	char str_cmd[MAX_COMD_LEN];
	int ntotal_pats;
	struct timeb start, end;
	double dmine_time, dpostproc_time;

	if(!strcmp(szprogram_name, "LCM"))
		sprintf(str_cmd, "%s %s %d temp.txt", szprogram_name, szdataset_name, nmin_sup);
	else
		sprintf(str_cmd, "%s %s %d %d %d temp.txt", szprogram_name, szdataset_name, ntype, nmin_sup, nmin_size);
	
	printf("%s\n", str_cmd);

	ftime(&start);
	ntotal_pats = system(str_cmd);
	ftime(&end);
	dmine_time = end.time-start.time+(double)(end.millitm-start.millitm)/1000;

	ftime(&start);
	GenTList(szdataset_name, ntype, nmin_sup, nmin_size, "temp.txt", szoutput_filename);
	ftime(&end);
	dpostproc_time = end.time-start.time+(double)(end.millitm-start.millitm)/1000;
}


